﻿@namespace ServiceDesk.Presentation.Components.Mantenimientos

@using System.Collections.ObjectModel
@using System.Collections;
@using Microsoft.AspNetCore.Components.Authorization

@inject UsuarioAgent usuarioAgent
@inject DepartamentoAgent departamentoAgent

<TelerikGrid Data=@GridData EditMode="@GridEditMode.Popup"
             Pageable="true" PageSize=25
             OnDelete=@DeleteItem>
    <GridToolBar>
        <GridCommandButton OnClick="CreateItem" Icon="add">Agregar Usuario</GridCommandButton>
    </GridToolBar>
    <GridColumns>
        <GridColumn Field=@nameof(UsuarioDto.Nombre) Editable="true">
            <Template>
                @{
                    var cn = context as UsuarioDto;
                    if (!string.IsNullOrEmpty(cn.Nombre) || !string.IsNullOrEmpty(cn.Apellido))
                    {
                        <text>@($"{cn.Nombre} {cn.Apellido}")</text>
                    }
                }
            </Template>
        </GridColumn>
        <GridColumn Field=@nameof(UsuarioDto.Correo) />
        <GridColumn Field=@nameof(UsuarioDto.PuestoId) Title="Puesto">
            <Template>
                @{
                    var puesto = (context as UsuarioDto);
                    <text>@(!string.IsNullOrEmpty(puesto.Puesto.Nombre) ? puesto.Puesto.Nombre : string.Empty)</text>
                }
            </Template>
        </GridColumn>

        <GridColumn Title="Departamentos">
            <Template>
                @{
                    var puesto = (context as UsuarioDto).Puesto;
                    <text>@(departamentos.Where(b => b.Id == puesto.DepartamentoId).FirstOrDefault().Nombre)</text>
                }
            </Template>
        </GridColumn>
        <GridCommandColumn Width="120px">
            <GridCommandButton OnClick="UpdateItem" Icon="edit"></GridCommandButton>
            <GridCommandButton Command="Delete" Icon="delete"></GridCommandButton>
        </GridCommandColumn>
    </GridColumns>
</TelerikGrid>

<ModalAddEditUsuario EventCallback ="CloseModal" WindowVisible="WinVisible" EsEdicion="EsEdicion" usuario="User"></ModalAddEditUsuario>


@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationState { get; set; }

    [CascadingParameter]
    private DialogFactory Dialog { get; set; }

    private bool WinVisible = false;

    private bool EsEdicion = false;

    public List<UsuarioDto> GridData { get; set; } = new List<UsuarioDto>();

    public List<DepartamentoDto> departamentos { get; set; } = new List<DepartamentoDto>();

    public UserInfo User { get; set; } = new UserInfo();

    protected override async Task OnInitializedAsync()
    {
        try
        {
            Timer timer = new Timer();
            timer.Interval = 5000;
            timer.Elapsed += timer_elapsed;
            await LoadData();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void timer_elapsed(object sender, ElapsedEventArgs e)
    {
        await LoadData();
    }

    private async Task LoadData()
    {
        try
        {
            GridData = await usuarioAgent.Get();
            departamentos = await departamentoAgent.Get();
            StateHasChanged();
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.Message);
            throw;
        }

    }

    private async void CreateItem(GridCommandEventArgs args)
    {
        EsEdicion = false;
        WinVisible = true;
    }

    private async void DeleteItem(GridCommandEventArgs args)
    {
        //PuestoDto puesto = args.Item as PuestoDto;
        //try
        //{
        //    if (await Dialog.ConfirmAsync("¿Está seguro que desea borrar este registro?"))
        //    {

        //    }
        //    await puestosAgent.Remove(puesto.Id);
        //}
        //catch (Exception ex)
        //{
        //    Console.WriteLine(ex.Message);
        //    throw;
        //}
        //StateHasChanged();
    }

    private async void UpdateItem(GridCommandEventArgs args)
    {
        UsuarioDto item = (args.Item as UsuarioDto);
        User = await usuarioAgent.GetById(item.Id);
        WinVisible = true;
        EsEdicion = true;

    }

    private void CloseModal()
    {
        User = new UserInfo();
        WinVisible = false;
    }

}